Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/mppini.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/mppini.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LBC/mppini.F90	(revision 14644)
@@ -1211,10 +1057,10 @@
       !! ** Method  : read stipe of size (Ni0glo,...)
       !!----------------------------------------------------------------------
-      INTEGER                         , INTENT(in   ) ::   kjstr       ! starting j position of the reading
-      INTEGER                         , INTENT(in   ) ::   kjcnt       ! number of lines to read
-      LOGICAL, DIMENSION(Ni0glo,kjcnt), INTENT(  out) ::   ldoce       ! ldoce(i,j) = .true. if the point (i,j) is ocean
-      !
-      INTEGER                           ::   inumsave                ! local logical unit
-      REAL(wp), DIMENSION(Ni0glo,kjcnt) ::   zbot, zbdy
+      INTEGER                        , INTENT(in   ) ::   kistr, kjstr   ! starting i and j position of the reading
+      INTEGER                        , INTENT(in   ) ::   kicnt, kjcnt   ! number of points to read in i and j directions
+      LOGICAL, DIMENSION(kicnt,kjcnt), INTENT(  out) ::   ldoce          ! ldoce(i,j) = .true. if the point (i,j) is ocean
+      !
+      INTEGER                          ::   inumsave                     ! local logical unit
+      REAL(wp), DIMENSION(kicnt,kjcnt) ::   zbot, zbdy
       !!----------------------------------------------------------------------
       !
@@ -1222,5 +1068,5 @@
       !
       IF( numbot /= -1 ) THEN
-         CALL iom_get( numbot, jpdom_unknown, 'bottom_level', zbot, kstart = (/1,kjstr/), kcount = (/Ni0glo, kjcnt/) )
+         CALL iom_get( numbot, jpdom_unknown, 'bottom_level', zbot, kstart = (/kistr,kjstr/), kcount = (/kicnt, kjcnt/) )
       ELSE
          zbot(:,:) = 1._wp                      ! put a non-null value
@@ -1228,15 +1074,15 @@
       !
       IF( numbdy /= -1 ) THEN                   ! Adjust with bdy_msk if it exists
-         CALL iom_get ( numbdy, jpdom_unknown,     'bdy_msk', zbdy, kstart = (/1,kjstr/), kcount = (/Ni0glo, kjcnt/) )
+         CALL iom_get ( numbdy, jpdom_unknown,     'bdy_msk', zbdy, kstart = (/kistr,kjstr/), kcount = (/kicnt, kjcnt/) )
          zbot(:,:) = zbot(:,:) * zbdy(:,:)
       ENDIF
       !
-      ldoce(:,:) = zbot(:,:) > 0._wp
+      ldoce(:,:) = NINT(zbot(:,:)) > 0
       numout = inumsave
       !
-   END SUBROUTINE readbot_strip
-
-
-   SUBROUTINE mpp_getnum( ldisoce, kproc, kipos, kjpos )
+   END SUBROUTINE read_mask
+
+
+   SUBROUTINE mpp_getnum( ldIsOce, kproc, kipos, kjpos )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE mpp_getnum  ***
@@ -1246,6 +1092,6 @@
       !! ** Method  : start from bottom left. First skip land subdomain, and finally use them if needed
       !!----------------------------------------------------------------------
-      LOGICAL, DIMENSION(:,:), INTENT(in   ) ::   ldisoce     ! F if land process
-      INTEGER, DIMENSION(:,:), INTENT(  out) ::   kproc       ! subdomain number (-1 if supressed, starting at 0)
+      LOGICAL, DIMENSION(:,:), INTENT(in   ) ::   ldIsOce     ! F if land process
+      INTEGER, DIMENSION(:,:), INTENT(  out) ::   kproc       ! subdomain number (-1 if not existing, starting at 0)
       INTEGER, DIMENSION(  :), INTENT(  out) ::   kipos       ! i-position of the subdomain (from 1 to jpni)
       INTEGER, DIMENSION(  :), INTENT(  out) ::   kjpos       ! j-position of the subdomain (from 1 to jpnj)
@@ -1255,6 +1101,6 @@
       !!----------------------------------------------------------------------
       !
-      ini = SIZE(ldisoce, dim = 1)
-      inj = SIZE(ldisoce, dim = 2)
+      ini = SIZE(ldIsOce, dim = 1)
+      inj = SIZE(ldIsOce, dim = 2)
       inij = SIZE(kipos)
       !
@@ -1266,5 +1112,5 @@
          ii = 1 + MOD(iarea0,ini)
          ij = 1 +     iarea0/ini
-         IF( ldisoce(ii,ij) ) THEN
+         IF( ldIsOce(ii,ij) ) THEN
             icont = icont + 1
             kproc(ii,ij) = icont
@@ -1274,10 +1120,10 @@
       END DO
       ! if needed add some land subdomains to reach inij active subdomains
-      i2add = inij - COUNT( ldisoce )
+      i2add = inij - COUNT( ldIsOce )
       DO jarea = 1, ini*inj
          iarea0 = jarea - 1
          ii = 1 + MOD(iarea0,ini)
          ij = 1 +     iarea0/ini
-         IF( .NOT. ldisoce(ii,ij) .AND. i2add > 0 ) THEN
+         IF( .NOT. ldIsOce(ii,ij) .AND. i2add > 0 ) THEN
             icont = icont + 1
             kproc(ii,ij) = icont
@@ -1289,4 +1135,93 @@
       !
    END SUBROUTINE mpp_getnum
+
+
+   SUBROUTINE init_excl_landpt
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE   ***
+      !!
+      !! ** Purpose : exclude exchanges which contain only land points
+      !!
+      !! ** Method  : if a send or receive buffer constains only land point we
+      !!              flag off the corresponding communication
+      !!              Warning: this selection depend on the halo size -> loop on halo size
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER ::   inumsave
+      INTEGER ::   jh
+      INTEGER ::   ipi, ipj
+      INTEGER ::   iiwe, iiea, iist, iisz 
+      INTEGER ::   ijso, ijno, ijst, ijsz 
+      LOGICAL ::   llsave
+      REAL(wp), DIMENSION(:,:), ALLOCATABLE ::   zmsk
+      LOGICAL , DIMENSION(Ni_0,Nj_0,1)      ::   lloce
+      !!----------------------------------------------------------------------
+      !
+      ! read the land-sea mask on the inner domain
+      CALL read_mask( nimpp, njmpp, Ni_0, Nj_0, lloce(:,:,1) )
+      !
+      ! Here we look only at communications excluding the NP folding.
+      ! As lbcnfd not validated if halo size /= nn_hls, we switch if off temporary...
+      llsave = l_IdoNFold
+      l_IdoNFold = .FALSE.
+      !
+      DO jh = 1, n_hlsmax    ! different halo size
+         !
+         ipi = Ni_0 + 2*jh   ! local domain size
+         ipj = Nj_0 + 2*jh
+         !
+         ALLOCATE( zmsk(ipi,ipj) )
+         zmsk(jh+1:jh+Ni_0,jh+1:jh+Nj_0) = REAL(COUNT(lloce, dim = 3), wp)   ! define inner domain -> need REAL to use lbclnk
+         CALL lbc_lnk('mppini', zmsk, 'T', 1._wp, khls = jh)                 ! fill halos
+         !        
+         iiwe = jh   ;   iiea = Ni_0   ! bottom-left corfer - 1 of the sent data
+         ijso = jh   ;   ijno = Nj_0
+         IF( nn_comm == 1 ) THEN 
+            iist =  0   ;   iisz = ipi
+            ijst =  0   ;   ijsz = ipj
+         ELSE
+            iist = jh   ;   iisz = Ni_0
+            ijst = jh   ;   ijsz = Nj_0
+         ENDIF
+IF( nn_comm == 1 ) THEN       ! SM: NOT WORKING FOR NEIGHBOURHOOD COLLECTIVE COMMUNICATIONS, I DON'T KNOW WHY... 
+         ! do not send if we send only land points
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiSnei(jh,jpwe) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiSnei(jh,jpea) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijso+1:ijso+jh  ) )) == 0 )   mpiSnei(jh,jpso) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijno+1:ijno+jh  ) )) == 0 )   mpiSnei(jh,jpno) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiSnei(jh,jpsw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiSnei(jh,jpse) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiSnei(jh,jpnw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiSnei(jh,jpne) = -1
+         !
+         iiwe = iiwe-jh   ;   iiea = iiea+jh   ! bottom-left corfer - 1 of the received data
+         ijso = ijso-jh   ;   ijno = ijno+jh
+         ! do not send if we send only land points
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiRnei(jh,jpwe) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijst+1:ijst+ijsz) )) == 0 )   mpiRnei(jh,jpea) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijso+1:ijso+jh  ) )) == 0 )   mpiRnei(jh,jpso) = -1
+         IF( NINT(SUM( zmsk(iist+1:iist+iisz,ijno+1:ijno+jh  ) )) == 0 )   mpiRnei(jh,jpno) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiRnei(jh,jpsw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijso+1:ijso+jh  ) )) == 0 )   mpiRnei(jh,jpse) = -1
+         IF( NINT(SUM( zmsk(iiwe+1:iiwe+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiRnei(jh,jpnw) = -1
+         IF( NINT(SUM( zmsk(iiea+1:iiea+jh  ,ijno+1:ijno+jh  ) )) == 0 )   mpiRnei(jh,jpne) = -1
+ENDIF
+         !
+         ! Specific (and rare) problem in corner treatment because we do 1st West-East comm, next South-North comm
+         IF( nn_comm == 1 ) THEN
+            IF( mpiSnei(jh,jpwe) > -1 )   mpiSnei(jh, (/jpsw,jpnw/) ) = -1   ! SW and NW corners already sent through West nei
+            IF( mpiSnei(jh,jpea) > -1 )   mpiSnei(jh, (/jpse,jpne/) ) = -1   ! SE and NE corners already sent through East nei
+            IF( mpiRnei(jh,jpso) > -1 )   mpiRnei(jh, (/jpsw,jpse/) ) = -1   ! SW and SE corners will be received through South nei
+            IF( mpiRnei(jh,jpno) > -1 )   mpiRnei(jh, (/jpnw,jpne/) ) = -1   ! NW and NE corners will be received through North nei
+        ENDIF
+         !
+         DEALLOCATE( zmsk )
+         !
+         CALL mpp_ini_nc(jh)    ! Initialize/Update communicator for neighbourhood collective communications
+         !
+      END DO
+      l_IdoNFold = llsave
+
+   END SUBROUTINE init_excl_landpt
 
 
@@ -1326,5 +1261,5 @@
       ENDIF
       !
-      CALL flio_dom_set ( jpnij, nproc, idid, iglo, iloc, iabsf, iabsl, ihals, ihale, 'BOX', nidom)
+      CALL flio_dom_set ( jpnij, narea-1, idid, iglo, iloc, iabsf, iabsl, ihals, ihale, 'BOX', nidom)
       !
    END SUBROUTINE init_ioipsl
@@ -1345,38 +1280,30 @@
       !!----------------------------------------------------------------------
       !
-      !initializes the north-fold communication variables
-      isendto(:) = 0
-      nsndto     = 0
-      !
-      IF ( njmpp == MAXVAL( njmppt ) ) THEN      ! if I am a process in the north
+      !sxM is the first point (in the global domain) needed to compute the north-fold for the current process
+      sxM = jpiglo - nimpp - jpi + 1
+      !dxM is the last point (in the global domain) needed to compute the north-fold for the current process
+      dxM = jpiglo - nimpp + 2
+      !
+      ! loop over the other north-fold processes to find the processes
+      ! managing the points belonging to the sxT-dxT range
+      !
+      nsndto = 0
+      DO jn = 1, jpni
          !
-         !sxM is the first point (in the global domain) needed to compute the north-fold for the current process
-         sxM = jpiglo - nimppt(narea) - jpiall(narea) + 1
-         !dxM is the last point (in the global domain) needed to compute the north-fold for the current process
-         dxM = jpiglo - nimppt(narea) + 2
+         sxT = nfimpp(jn)                    ! sxT = 1st  point (in the global domain) of the jn process
+         dxT = nfimpp(jn) + nfjpi(jn) - 1    ! dxT = last point (in the global domain) of the jn process
          !
-         ! loop over the other north-fold processes to find the processes
-         ! managing the points belonging to the sxT-dxT range
+         IF    ( sxT < sxM  .AND.  sxM < dxT ) THEN
+            nsndto          = nsndto + 1
+            isendto(nsndto) = jn
+         ELSEIF( sxM <= sxT  .AND.  dxM >= dxT ) THEN
+            nsndto          = nsndto + 1
+            isendto(nsndto) = jn
+         ELSEIF( dxM <  dxT  .AND.  sxT <  dxM ) THEN
+            nsndto          = nsndto + 1
+            isendto(nsndto) = jn
+         ENDIF
          !
-         DO jn = 1, jpni
-            !
-            sxT = nfimpp(jn)                    ! sxT = 1st  point (in the global domain) of the jn process
-            dxT = nfimpp(jn) + nfjpi(jn) - 1    ! dxT = last point (in the global domain) of the jn process
-            !
-            IF    ( sxT < sxM  .AND.  sxM < dxT ) THEN
-               nsndto          = nsndto + 1
-               isendto(nsndto) = jn
-            ELSEIF( sxM <= sxT  .AND.  dxM >= dxT ) THEN
-               nsndto          = nsndto + 1
-               isendto(nsndto) = jn
-            ELSEIF( dxM <  dxT  .AND.  sxT <  dxM ) THEN
-               nsndto          = nsndto + 1
-               isendto(nsndto) = jn
-            ENDIF
-            !
-         END DO
-         !
-      ENDIF
-      l_north_nogather = .TRUE.
+      END DO
       !
    END SUBROUTINE init_nfdcom
@@ -1391,28 +1318,16 @@
       !!----------------------------------------------------------------------
       !
-      Nis0 =   1+nn_hls   ;   Nis1 = Nis0-1   ;   Nis2 = MAX(  1, Nis0-2)
-      Njs0 =   1+nn_hls   ;   Njs1 = Njs0-1   ;   Njs2 = MAX(  1, Njs0-2)
-      !
-      Nie0 = jpi-nn_hls   ;   Nie1 = Nie0+1   ;   Nie2 = MIN(jpi, Nie0+2)
-      Nje0 = jpj-nn_hls   ;   Nje1 = Nje0+1   ;   Nje2 = MIN(jpj, Nje0+2)
-      !
-      IF( nn_hls == 1 ) THEN          !* halo size of 1
-         !
-         Nis1nxt2 = Nis0   ;   Njs1nxt2 = Njs0
-         Nie1nxt2 = Nie0   ;   Nje1nxt2 = Nje0
-         !
-      ELSE                            !* larger halo size...
-         !
-         Nis1nxt2 = Nis1   ;   Njs1nxt2 = Njs1
-         Nie1nxt2 = Nie1   ;   Nje1nxt2 = Nje1
-         !
-      ENDIF
+      Nis0 =   1+nn_hls
+      Njs0 =   1+nn_hls
+      Nie0 = jpi-nn_hls
+      Nje0 = jpj-nn_hls
       !
       Ni_0 = Nie0 - Nis0 + 1
       Nj_0 = Nje0 - Njs0 + 1
-      Ni_1 = Nie1 - Nis1 + 1
-      Nj_1 = Nje1 - Njs1 + 1
-      Ni_2 = Nie2 - Nis2 + 1
-      Nj_2 = Nje2 - Njs2 + 1
+      !
+      ! old indices to be removed...
+      jpim1 = jpi-1                             ! inner domain indices
+      jpjm1 = jpj-1                             !   "           "
+      jpkm1 = jpk-1                             !   "           "
       !
    END SUBROUTINE init_doloop
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfc1d_c2d.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfc1d_c2d.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfc1d_c2d.F90	(revision 14644)
@@ -95,5 +95,5 @@
          END_3D
          ! Lateral boundary conditions
-         CALL lbc_lnk_multi( 'ldfc1d_c2d', pah1, 'U', 1.0_wp , pah2, 'V', 1.0_wp )
+         CALL lbc_lnk( 'ldfc1d_c2d', pah1, 'U', 1.0_wp , pah2, 'V', 1.0_wp )
          !
       CASE DEFAULT                        ! error
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfdyn.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfdyn.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfdyn.F90	(revision 14644)
@@ -99,7 +99,7 @@
       !!    nn_ahm_ijk_t  =  0 => = constant
       !!                  = 10 => = F(z) :     = constant with a reduction of 1/4 with depth 
-      !!                  =-20 => = F(i,j)     = shape read in 'eddy_viscosity.nc' file
+      !!                  =-20 => = F(i,j)     = shape read in 'eddy_viscosity_2D.nc' file
       !!                  = 20    = F(i,j)     = F(e1,e2) or F(e1^3,e2^3) (lap or bilap case)
-      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_viscosity.nc'  file
+      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_viscosity_3D.nc'  file
       !!                  = 30    = F(i,j,k)   = 2D (case 20) + decrease with depth (case 10)
       !!                  = 31    = F(i,j,k,t) = F(local velocity) (  |u|e  /12   laplacian operator
@@ -412,5 +412,5 @@
          ENDIF
          !
-         CALL lbc_lnk_multi( 'ldfdyn', ahmt, 'T', 1.0_wp,  ahmf, 'F', 1.0_wp )
+         CALL lbc_lnk( 'ldfdyn', ahmt, 'T', 1.0_wp,  ahmf, 'F', 1.0_wp )
          !
          !
@@ -444,5 +444,5 @@
             END DO
             !
-            CALL lbc_lnk_multi( 'ldfdyn', dtensq, 'T', 1.0_wp )  ! lbc_lnk on dshesq not needed
+            CALL lbc_lnk( 'ldfdyn', dtensq, 'T', 1.0_wp )  ! lbc_lnk on dshesq not needed
             !
             DO jk = 1, jpkm1
@@ -495,5 +495,5 @@
          ENDIF
          !
-         CALL lbc_lnk_multi( 'ldfdyn', ahmt, 'T', 1.0_wp , ahmf, 'F', 1.0_wp )
+         CALL lbc_lnk( 'ldfdyn', ahmt, 'T', 1.0_wp , ahmf, 'F', 1.0_wp )
          !
       END SELECT
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfslp.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfslp.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldfslp.F90	(revision 14644)
@@ -229,5 +229,5 @@
 !!gm end modif
       END_3D
-      CALL lbc_lnk_multi( 'ldfslp', zwz, 'U', -1.0_wp,  zww, 'V', -1.0_wp )      ! lateral boundary conditions
+      CALL lbc_lnk( 'ldfslp', zwz, 'U', -1.0_wp,  zww, 'V', -1.0_wp )      ! lateral boundary conditions
       !
       !                                    !* horizontal Shapiro filter
@@ -245,18 +245,4 @@
                &                       + 4.*  zww(ji,jj    ,jk)                       )
          END_2D
-         DO jj = 3, jpj-2                                    ! other rows
-            DO ji = 2, jpim1   ! vector opt.
-               uslp(ji,jj,jk) = z1_16 * (        zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)      &
-                  &                       +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)      &
-                  &                       + 2.*( zwz(ji  ,jj-1,jk) + zwz(ji-1,jj  ,jk)      &
-                  &                       +      zwz(ji+1,jj  ,jk) + zwz(ji  ,jj+1,jk) )    &
-                  &                       + 4.*  zwz(ji  ,jj  ,jk)                       )
-               vslp(ji,jj,jk) = z1_16 * (        zww(ji-1,jj-1,jk) + zww(ji+1,jj-1,jk)      &
-                  &                       +      zww(ji-1,jj+1,jk) + zww(ji+1,jj+1,jk)      &
-                  &                       + 2.*( zww(ji  ,jj-1,jk) + zww(ji-1,jj  ,jk)      &
-                  &                       +      zww(ji+1,jj  ,jk) + zww(ji  ,jj+1,jk) )    &
-                  &                       + 4.*  zww(ji,jj    ,jk)                       )
-            END DO
-         END DO
          !                                 !* decrease along coastal boundaries
          DO_2D( 0, 0, 0, 0 )
@@ -303,5 +289,5 @@
 !!gm end modif
       END_3D
-      CALL lbc_lnk_multi( 'ldfslp', zwz, 'T', -1.0_wp,  zww, 'T', -1.0_wp )      ! lateral boundary conditions
+      CALL lbc_lnk( 'ldfslp', zwz, 'T', -1.0_wp,  zww, 'T', -1.0_wp )      ! lateral boundary conditions
       !
       !                                           !* horizontal Shapiro filter
@@ -321,20 +307,4 @@
                  &               + 4.*  zww(ji  ,jj  ,jk)                         ) * zcofw
          END_2D
-         DO jj = 3, jpj-2                               ! other rows
-            DO ji = 2, jpim1   ! vector opt.
-               zcofw = wmask(ji,jj,jk) * z1_16
-               wslpi(ji,jj,jk) = (         zwz(ji-1,jj-1,jk) + zwz(ji+1,jj-1,jk)     &
-                    &               +      zwz(ji-1,jj+1,jk) + zwz(ji+1,jj+1,jk)     &
-                    &               + 2.*( zwz(ji  ,jj-1,jk) + zwz(ji-1,jj  ,jk)     &
-                    &               +      zwz(ji+1,jj  ,jk) + zwz(ji  ,jj+1,jk) )   &
-                    &               + 4.*  zwz(ji  ,jj  ,jk)                         ) * zcofw
-
-               wslpj(ji,jj,jk) = (         zww(ji-1,jj-1,jk) + zww(ji+1,jj-1,jk)     &
-                    &               +      zww(ji-1,jj+1,jk) + zww(ji+1,jj+1,jk)     &
-                    &               + 2.*( zww(ji  ,jj-1,jk) + zww(ji-1,jj  ,jk)     &
-                    &               +      zww(ji+1,jj  ,jk) + zww(ji  ,jj+1,jk) )   &
-                    &               + 4.*  zww(ji  ,jj  ,jk)                         ) * zcofw
-            END DO
-         END DO
          !                                        !* decrease in vicinity of topography
          DO_2D( 0, 0, 0, 0 )
@@ -348,5 +318,5 @@
       ! IV. Lateral boundary conditions
       ! ===============================
-      CALL lbc_lnk_multi( 'ldfslp', uslp , 'U', -1.0_wp , vslp , 'V', -1.0_wp , wslpi, 'W', -1.0_wp, wslpj, 'W', -1.0_wp )
+      CALL lbc_lnk( 'ldfslp', uslp , 'U', -1.0_wp , vslp , 'V', -1.0_wp , wslpi, 'W', -1.0_wp, wslpj, 'W', -1.0_wp )
 
       IF(sn_cfctl%l_prtctl) THEN
@@ -689,5 +659,5 @@
       END_2D
       !!gm this lbc_lnk should be useless....
-      CALL lbc_lnk_multi( 'ldfslp', uslpml , 'U', -1.0_wp , vslpml , 'V', -1.0_wp , wslpiml, 'W', -1.0_wp , wslpjml, 'W', -1.0_wp ) 
+      CALL lbc_lnk( 'ldfslp', uslpml , 'U', -1.0_wp , vslpml , 'V', -1.0_wp , wslpiml, 'W', -1.0_wp , wslpjml, 'W', -1.0_wp ) 
       !
    END SUBROUTINE ldf_slp_mxl
@@ -757,5 +727,5 @@
 !               END DO
 !            END DO
-!            CALL lbc_lnk_multi( 'ldfslp', uslp , 'U', -1. ; CALL lbc_lnk( 'ldfslp', vslp , 'V', -1.,  wslpi, 'W', -1.,  wslpj, 'W', -1. )
+!            CALL lbc_lnk( 'ldfslp', uslp , 'U', -1. ; CALL lbc_lnk( 'ldfslp', vslp , 'V', -1.,  wslpi, 'W', -1.,  wslpj, 'W', -1. )
 !!gm         ENDIF
       ENDIF
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldftra.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldftra.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/LDF/ldftra.F90	(revision 14644)
@@ -118,9 +118,9 @@
       !!                  = 10 => = F(z) : constant with a reduction of 1/4 with depth
       !!                  !
-      !!                  =-20 => = F(i,j)   = shape read in 'eddy_diffusivity.nc' file
+      !!                  =-20 => = F(i,j)   = shape read in 'eddy_diffusivity_2D.nc' file
       !!                  = 20    = F(i,j)   = F(e1,e2) or F(e1^3,e2^3) (lap or bilap case)
       !!                  = 21    = F(i,j,t) = F(growth rate of baroclinic instability)
       !!                  !
-      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_diffusivity.nc' file
+      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_diffusivity_3D.nc' file
       !!                  = 30    = F(i,j,k)   = 2D (case 20) + decrease with depth (case 10)
       !!                  = 31    = F(i,j,k,t) = F(local velocity) (  1/2  |u|e     laplacian operator
@@ -481,9 +481,9 @@
       !!                  = 10 => = F(z) : constant with a reduction of 1/4 with depth
       !!                  !
-      !!                  =-20 => = F(i,j)   = shape read in 'eddy_diffusivity.nc' file
+      !!                  =-20 => = F(i,j)   = shape read in 'eddy_induced_velocity_2D.nc' file
       !!                  = 20    = F(i,j)   = F(e1,e2) or F(e1^3,e2^3) (lap or bilap case)
       !!                  = 21    = F(i,j,t) = F(growth rate of baroclinic instability)
       !!                  !
-      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_diffusivity.nc' file
+      !!                  =-30 => = F(i,j,k)   = shape read in 'eddy_induced_velocity_3D.nc' file
       !!                  = 30    = F(i,j,k)   = 2D (case 20) + decrease with depth (case 10)
       !!
@@ -697,5 +697,5 @@
          paeiv(ji,jj,1) = 0.5_wp * ( zaeiw(ji,jj) + zaeiw(ji  ,jj+1) ) * vmask(ji,jj,1)
       END_2D
-      CALL lbc_lnk_multi( 'ldftra', paeiu(:,:,1), 'U', 1.0_wp , paeiv(:,:,1), 'V', 1.0_wp )      ! lateral boundary condition
+      CALL lbc_lnk( 'ldftra', paeiu(:,:,1), 'U', 1.0_wp , paeiv(:,:,1), 'V', 1.0_wp )      ! lateral boundary condition
 
       DO jk = 2, jpkm1                          !==  deeper values equal the surface one  ==!
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/mpp_map.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/mpp_map.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/mpp_map.F90	(revision 14644)
@@ -13,5 +13,5 @@
    USE par_oce , ONLY :   jpi, jpj, Nis0, Nie0, Njs0, Nje0   ! Ocean parameters
    USE dom_oce , ONLY :   mig, mjg, narea                    ! Ocean space and time domain variables
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
    USE lib_mpp , ONLY :   mpi_comm_oce   ! MPP library
 #endif
@@ -45,5 +45,5 @@
       !!----------------------------------------------------------------------
       INTEGER, DIMENSION(:,:), ALLOCATABLE ::   imppmap   !
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
       INTEGER :: ierr
 
@@ -69,5 +69,5 @@
       ! Get global data
 
-#if defined key_mpp_mpi
+#if ! defined key_mpi_off
 
       ! Call the MPI library to find the max across processors
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_averg_h2d.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_averg_h2d.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/OBS/obs_averg_h2d.F90	(revision 14644)
@@ -21,6 +21,5 @@
       & e1t, e2t, &
       & e1f, e2f, &
-      & glamt, gphit, &
-      & nproc
+      & glamt, gphit
    USE in_out_manager
    USE obs_const, ONLY : &
